"use strict";

exports.__esModule = true;
exports.varsToStyles = varsToStyles;
exports.jsx = jsx;
exports.default = exports.resolveVariants = void 0;

var _react = require("react");

exports.F = _react.Fragment;

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const resolveVariants = variants => !variants ? '' : variants.filter(Boolean).join(' ');

exports.resolveVariants = resolveVariants;

function varsToStyles(props, vars) {
  if (!vars || !vars.length) return props.style;
  const style = Object.assign({}, props.style);
  vars.forEach(([id, value, unit = '']) => {
    const result = typeof value === 'function' ? value(props) : value;
    style[`--${id}`] = `${result}${unit}`;
  });
  return style;
}

function jsx(type, props, ...children) {
  if (props && props.css) {
    const {
      css,
      className
    } = props,
          childProps = _objectWithoutPropertiesLoose(props, ["css", "className"]);

    const componentClassName = css[0].cls2 || css[0].cls1;
    childProps.style = varsToStyles(childProps, css[1]);
    childProps.className = `${className ? `${className} ${componentClassName}` : componentClassName} ${resolveVariants(css[2])}`;
    props = childProps;
  }

  return /*#__PURE__*/(0, _react.createElement)(type, props, ...children);
}

jsx.F = _react.Fragment; // the reason for the crazy exports here is that you need to do a BUNCH of work
// to keep typescript from eliding (removing) the jsx imports
// see: https://github.com/babel/babel/pull/11523

var _default = jsx;
exports.default = _default;