"use strict";

exports.__esModule = true;
exports.getNameFromFile = getNameFromFile;
exports.createRequirePath = createRequirePath;
exports.default = createFilename;

var _path = require("path");

var _pascalCase = _interopRequireDefault(require("./pascalCase"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getNameFromFile(fileName) {
  const name = (0, _path.basename)(fileName, (0, _path.extname)(fileName));
  if (name !== 'index') return (0, _pascalCase.default)(name);
  return (0, _pascalCase.default)((0, _path.basename)((0, _path.dirname)(fileName)));
}

function createRequirePath(from, to) {
  let relativePath = (0, _path.relative)((0, _path.dirname)(from), to);

  if (!relativePath.startsWith('.')) {
    relativePath = `./${relativePath}`;
  }

  return relativePath;
}

function createFilename(hostFile, {
  extension = '.module.css'
}, id) {
  let base;
  if (getNameFromFile(hostFile) === id) base = id;else base = `${(0, _path.basename)(hostFile, (0, _path.extname)(hostFile))}-${id}`;
  return (0, _path.join)((0, _path.dirname)(hostFile), base + extension);
}