"use strict";

exports.__esModule = true;
exports.default = getDisplayName;

var _createFilename = require("./createFilename");

var _getNameFromPath = _interopRequireDefault(require("./getNameFromPath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getDisplayName(path, {
  file
}, defaultName = (0, _createFilename.getNameFromFile)(file.opts.filename)) {
  // eslint-disable-next-line no-cond-assign
  while (path = path.parentPath) {
    if (path.isVariableDeclarator()) return (0, _getNameFromPath.default)(path.get('id'));
    if (path.isAssignmentExpression()) return (0, _getNameFromPath.default)(path.get('left'));
    if (path.isExportDefaultDeclaration()) return (0, _createFilename.getNameFromFile)(file.opts.filename);
  }

  return defaultName || null;
}