"use strict";

exports.__esModule = true;
exports.default = getNameFromPath;

var _getMembers = _interopRequireDefault(require("./getMembers"));

var _pascalCase = _interopRequireDefault(require("./pascalCase"));

var _truthy = _interopRequireDefault(require("./truthy"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const getLiteralValue = node => node.raw || node.value;

function getNameFromPath(path) {
  if (path.isIdentifier() || path.isJSXIdentifier()) return path.node.name;
  if (path.isLiteral()) return getLiteralValue(path.node);

  if (path.isMemberExpression() || path.isJSXMemberExpression()) {
    return (0, _pascalCase.default)((0, _getMembers.default)(path).map(m => getNameFromPath(m.path)).filter(_truthy.default).join('-'));
  }

  return null;
}