"use strict";

exports.__esModule = true;
exports.default = isStyledTag;

var _hasAttrs = _interopRequireDefault(require("./hasAttrs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isAttrsExpression = (calleePath, pluginOptions) => (0, _hasAttrs.default)(calleePath) && // eslint-disable-next-line @typescript-eslint/no-use-before-define
isStyledTag(calleePath.get('object'), pluginOptions);

const isStyledExpression = (calleePath, {
  styledTagName,
  allowGlobal
}) => styledTagName !== false && calleePath.node.name === styledTagName && (allowGlobal || calleePath.referencesImport('astroturf/react'));

function isStyledTag(tagPath, pluginOptions) {
  const callee = tagPath.get('callee');
  return tagPath.isCallExpression() && (isAttrsExpression(callee, pluginOptions) || isStyledExpression(callee, pluginOptions));
}